<!DOCTYPE html>
<html>
<head>
  <title>Object Detection</title>
</head>
<body>
  <h1>Object Detection</h1>
  <form action="/detect" method="POST" enctype="multipart/form-data">
    <input type="file" name="image">
    <button type="submit">Detect Objects</button>
  </form>
  <canvas id="canvas"></canvas>
  <script>
    const canvas = document.getElementById('canvas');
    const context = canvas.getContext('2d');

   function drawBoundingBoxes(image, boxes) {
  // Set the canvas size to match the image size
  canvas.width = image.width;
  canvas.height = image.height;

  // Draw the image on the canvas
  context.drawImage(image, 0, 0);

  // Loop through the bounding boxes and draw them on the image
  for (const box of boxes) {
    const x = box.xmin;
    const y = box.ymin;
    const w = box.xmax - box.xmin;
    const h = box.ymax - box.ymin;

    context.strokeStyle = 'red';
    context.lineWidth = 2;
    context.strokeRect(x, y, w, h);
    
    // Add label text to the bounding box
    context.font = '16px Arial';
    context.fillStyle = 'red';
    context.fillText(box.class, x, y - 5);
  }
}

    const form = document.querySelector('form');
    form.addEventListener('submit', async (event) => {
      event.preventDefault();
      const formData = new FormData(event.target);
      const response = await fetch('/detect', {
        method: 'POST',
        body: formData
      });
      const data = await response.json();
      const image = new Image();
      image.onload = () => drawBoundingBoxes(image, data.boxes);
      image.src = 'data:image/jpeg;base64,' + data.image;
    });
  </script>
</body>
</html>
